summaryrefslogtreecommitdiff
path: root/tests.merging/basic.script
diff options
context:
space:
mode:
Diffstat (limited to 'tests.merging/basic.script')
-rwxr-xr-xtests.merging/basic.script86
1 files changed, 86 insertions, 0 deletions
diff --git a/tests.merging/basic.script b/tests.merging/basic.script
new file mode 100755
index 00000000..741e8a3f
--- /dev/null
+++ b/tests.merging/basic.script
@@ -0,0 +1,86 @@
+#!/bin/sh
+# Copyright (C) 2012 Codethink Limited
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; version 2 of the License.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License along
+# with this program; if not, write to the Free Software Foundation, Inc.,
+# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+
+# Check that "morph merge" merges a system branch into a newly created
+# system branch
+
+set -eu
+
+# Disable test on versions of Python before 2.7.
+if ! python --version 2>&1 | grep '^Python 2\.[78]' > /dev/null
+then
+ exit 0
+fi
+
+cd "$DATADIR/workspace"
+"$SRCDIR/scripts/test-morph" init
+
+# Create stable branch to merge TO
+"$SRCDIR/scripts/test-morph" branch baserock:morphs test/stable
+cd test/stable/baserock:morphs
+git push --quiet origin test/stable
+
+# Create feature branch to merge FROM
+"$SRCDIR/scripts/test-morph" branch baserock:morphs test/feature test/stable
+cd "$DATADIR/workspace/test/feature"
+
+# Edit hello in FROM
+"$SRCDIR/scripts/test-morph" edit hello-system hello-stratum hello
+cd baserock:hello
+touch newfile.txt
+git add newfile.txt
+git commit -m foo --quiet
+
+# Commit in morphs repo
+# FIXME: this should become unnecessary since only the refs have
+# changed.
+cd ../baserock:morphs
+git commit --all --quiet -m "Update morph refs for test/feature"
+
+# Merge changes back to test/stable
+cd "$DATADIR/workspace"
+cd test/stable
+"$SRCDIR/scripts/test-morph" merge test/feature
+
+# Check results: changes to 'hello' should have been merged back to
+# test/stable.
+cd baserock:hello
+[ -e newfile.txt ]
+
+# Make sure all changes are committed and to the correct branch ('hello'
+# was built from 'master' before branching, so the changes should be
+# merged back to 'master').
+git status --short
+[ $(git rev-parse master) = $(git rev-parse HEAD) ]
+
+# Changes here should be on test/stable.
+cd ../baserock:morphs
+git status --short
+[ $(git rev-parse test/stable) = $(git rev-parse HEAD) ]
+
+# Make sure all refs to the merged branch have gone.
+! grep "\"ref\": \"test/feature\"" *.morph
+
+# The only change here was the branch refs, which have now been
+# changed back - so there should not be any new commits.
+echo "Commit message for baserock:morphs"
+git cat-file commit HEAD | tail -n 1
+
+echo
+echo "Commit message for baserock:hello"
+cd ../baserock:hello
+git cat-file commit HEAD | tail -n 1
+